#!/mnt/syb8634/server/php5-cgi -qd register_argc_argv=1
<?php
/*
 * Mono Wrapper - Acceps various playlists and auto-mounts shares
 *                before calling mono
 * By: Erik Bernhardson
 * Date: 2-20-2009
 */

define('SYSPATH', dirname(realpath($argv[0])));
define('DEBUG', TRUE);
define('LOG', '/tmp/mono.log');
define('IS_NMT', file_exists('/bin/mono.real'));

ini_set('include_path', SYSPATH);

require_once 'config.php';
/* Default values incase config.php doesn't have them */
if(!defined('BOOT_SHARE'))
  define('BOOT_SHARE', False);

if(!defined('SAVE_MONO_SETTINGS'))
  define('SAVE_MONO_SETTINGS', True);

if(!defined('REVERT_UDN'))
  define('REVERT_UDN', False);

/* must be after all the define statements */
require_once 'php/utils.php';

function _log($msg) {
  file_put_contents(LOG, "$msg\n", FILE_APPEND);
  echo "$msg\n";
  return $msg;
}

_log("\nStarting Mono.Wrapper: ".implode(' ', $argv));

$parsePlaylist = $fileIdx = False;

/* This is simpler, but can it fail easier? 
foreach($argv as $key => $item) {
  if($item == '-single') {
    _log('single');
    $fileIdx = $key+1;
    break;
  } else if($item == '-playlist') {
    _log('playlist');
    $fileIdx = $key+1;
    $parsePlaylist = True;
    break;
  }
} */


if($argc == 2 && $argv[1] == '-initialize') {
  if(SAVE_MONO_SETTINGS) {
    _log('Restoring saved mono settings');
    $dir = SYSPATH.'/saved.settings';
    foreach(array('mono_bookmark', 'mono_settings') as $file) {
      if(file_exists("$dir/$file")) {
          copy("$dir/$file", "/tmp/$file");
      } else _log ("No $file to load from $dir");
    }
  } else _log('Not configured to restore mono settings');
  
  if(BOOT_SHARE) {
    $dest='http://localhost.drives:8883/';
    if(!file_exists('/opt/sybhttpd/localhost.drives/'.BOOT_SHARE)) {
      $dest .= 'NETWORK_SHARE/';
      mountFilesystemByName(BOOT_SHARE);
      if(!alreadyMounted(BOOT_SHARE)) {
        _log('Mount Failed');
        exit();
      }
    } else _log('Drive is Local: '.BOOT_SHARE);
    
    $dest .= BOOT_SHARE.'/?home=0';
    _log('Sending bootup url: '.$dest);
    file_put_contents('/tmp/gaya_bc', $dest, FILE_APPEND);
  } else _log('No share to mount on boot');

  exit();
}

// Videos
if($argc >= 3) {
  if($argv[1] == '-single') {
    _log('single');
    $fileIdx = 2;
  } else if($argv[1] == '-playlist') {
    _log('playlist');
    $fileIdx = 2;
    $parsePlaylist = True;
  }
}

// Music
if($fileIdx === False && $argc >= 5) {
  if($argv[1] == '-audio' && $argv[2] == '-bgimg') {
    if($argv[3] == '-single') {
      _log('audio single');
      $fileIdx = 4;
    } else if($argv[3] == '-playlist') {
      _log('audio playlist');
      $fileIdx = 4;
      $parsePlaylist = True;
    }
  }
}

// Do the actual work
if($fileIdx !== False) {
  mountFilesystemByPath($argv[$fileIdx]);

  if($parsePlaylist === True)
    $argv[$fileIdx] = playlist2jsp($argv[$fileIdx]);
}

executeMono($argv);

// Save bookmarks/zoom settings from mono to the hard disk to restore on reboot
if(SAVE_MONO_SETTINGS) {
  _log('Saving mono settings for incase of reboot');
  $dest=SYSPATH.'/saved.settings/';
  if(!is_dir($dest)) {
    @unlink($dest);
    mkdir($dest, 0777, TRUE);
  }
  foreach(array('mono_bookmark', 'mono_settings') as $file) {
    copy("/tmp/$file", "$dest/$file");
  }
}


