<?php
/**
* JSP Writer - Outputs JSP(NMT) formatted playlists
* M3U Parser - Parses playlist objects such as the Title and File location
* By: Robert Widdick
* Date: 12-21-2008
* Join #php @ irc.efnet.net
*
* Version: 1.0
*/

/**
*@desc m3u class to parse file names and file locations
*/
class jsp {
  private $basePath = '';
  private $files = array();
  public  $total = 0;

  /**
  *@desc define variables and prepare file
  */
  public function __construct() {
  }

  /**
  *@desc unset the class to free up memory
  */
  public function __destruct() {
    unset($this);
  }

  /**
  *@desc add a file to the playlist
  */
  public function addFile($filename, $title) {
    $this -> files[] = array($filename, 0, 0, $title);
    $this -> total++;
  }

  /**
  *@desc set the path which files are relative to
  */
  public function setBasePath($path) {
    if(substr($path, -1) != '/')
      $path .= '/';
    $this -> basePath = $path;
  }

  public function shufflePlaylist() {
    shuffle($this -> files);
  }

  /**
  *@desc get the files' full path (+1 index from title name)
  */
  public function getPlaylist($randomize = FALSE) {
    $playlist = array();
    foreach($this -> files as $file) {
      if(substr($file[0], 0, 1) == '/' || preg_match('/^\w+:\/\//', $file[0]))
        $prefix = '';
      else
        $prefix = $this -> basePath;
      $playlist[] = $prefix.$file[0].'|'.$file[1].'|'.$file[2].'|'.$file[3]."|";
    }
    return implode("\n", $playlist);
  }
}

/* E X A M P L E
 *
 * $jsp = new jsp();
 * $fileList = array(array('/share/Music/Song1.mp3', 'Test Song 1'),
 *                   array('/share/Music/Song2.mp3', 'Another Test'),
 *                   array('/share/Music/Song3.mp3', 'Last Test'));
 * foreach($fileList as $file)
 *   $jsp -> addFile($file[0],$file[1]);
 * var_dump($jsp -> getPlaylist());
 */
?>
